VERSION 5.00
Object = "{5802683F-7C97-4325-82F1-B1E79DA1DCC3}#1.0#0"; "AkemiPowerPack.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5835
   ClientLeft      =   90
   ClientTop       =   465
   ClientWidth     =   6525
   LinkTopic       =   "Form1"
   ScaleHeight     =   389
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   435
   StartUpPosition =   3  'Windows Default
   Begin AkemiPowerPack.PowerForm PowerForm1 
      Left            =   3000
      Top             =   1440
      _ExtentX        =   423
      _ExtentY        =   397
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   8
      Left            =   4920
      Picture         =   "Form1.frx":0000
      Top             =   3480
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   7
      Left            =   4920
      Picture         =   "Form1.frx":128A
      Top             =   2880
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   6
      Left            =   4920
      Picture         =   "Form1.frx":2514
      Top             =   2280
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   5
      Left            =   4920
      Picture         =   "Form1.frx":379E
      Top             =   1680
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   4
      Left            =   4080
      Picture         =   "Form1.frx":4A28
      Top             =   3000
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   3
      Left            =   4080
      Picture         =   "Form1.frx":5CB2
      Top             =   2280
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   2
      Left            =   4080
      Picture         =   "Form1.frx":6F3C
      Top             =   1560
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   1
      Left            =   4080
      Picture         =   "Form1.frx":81C6
      Top             =   840
      Visible         =   0   'False
      Width           =   585
   End
   Begin VB.Image imgm 
      Height          =   585
      Index           =   0
      Left            =   4080
      Picture         =   "Form1.frx":9450
      Top             =   120
      Visible         =   0   'False
      Width           =   585
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Demonstration of using standard Windows scroll bars,
'and trapping scroll events using a PowerForm control.

'2001 Akemi
'Registered licensees of Akemi Power Pack may use or
'modify this example to their heart's content.

Private Const lcCellWidth As Long = 39
Private Const lcCellHeight As Long = 39
Private Const lcCellsX As Long = 20
Private Const lcCellsY As Long = 20

Private lmHorizontalScrollPos As Long
Private lmVerticalScrollPos As Long
Private lmMouseCellX As Long
Private lmMouseCellY As Long
Private bmMouseDown As Boolean

'Array to store map
Private almCellImageIndex(lcCellsX, lcCellsY) As Long

Private Sub Form_Load()
    'Load the map file that I created earlier.
    LoadMapFile App.Path & "\MyMap.txt"
    
    'Scrolling properties must be initialized
    'during the Form_Load event in order
    'to work correctly.  If the next 6 lines are
    'omitted then the program will appear to work,
    'except that the ScrollPage properties won't take.
    PowerForm1.MinHorizontalScroll = 0
    PowerForm1.MaxHorizontalScroll = lcCellWidth * lcCellsX
    PowerForm1.MinVerticalScroll = 0
    PowerForm1.MaxVerticalScroll = lcCellHeight * lcCellsY

    PowerForm1.HorizontalScrollPage = lcCellWidth
    PowerForm1.VerticalScrollPage = lcCellHeight
    
    Form2.Show vbModeless
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim lImageIndex As Long
    
    bmMouseDown = True
    
    'Get the index of the currently selected tile type
    'from Form2.
    lImageIndex = Val(Form2.lblmSelectedTileIndex.Caption)
    almCellImageIndex(lmMouseCellX, lmMouseCellY) = lImageIndex
    'Repaint the cell that has just been modified.
    PaintPicture imgm(lImageIndex), lmMouseCellX * lcCellWidth - lmHorizontalScrollPos, _
                                                lmMouseCellY * lcCellHeight - lmVerticalScrollPos
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim lImageIndex As Long
    Dim lNewMouseCellX As Long
    Dim lNewMouseCellY As Long
    
    'Translate form coordinates to cell coordinates
    lNewMouseCellX = (x + lmHorizontalScrollPos) \ lcCellWidth
    lNewMouseCellY = (y + lmVerticalScrollPos) \ lcCellHeight

    'If the position has changed, and the mouse button is still down,
    'then change the tile in the cell that the mouse pointer is now over.
    If lNewMouseCellX <> lmMouseCellX Or lNewMouseCellY <> lmMouseCellY Then
        If bmMouseDown Then
            'Get the index of the currently selected tile type.
            lImageIndex = Val(Form2.lblmSelectedTileIndex.Caption)
            almCellImageIndex(lNewMouseCellX, lNewMouseCellY) = lImageIndex
            'Repaint the cell that has just been modified.
            PaintPicture imgm(lImageIndex), lNewMouseCellX * lcCellWidth - lmHorizontalScrollPos, _
                                                        lNewMouseCellY * lcCellHeight - lmVerticalScrollPos
        End If
    End If
    
    'Store the current position
    lmMouseCellX = lNewMouseCellX
    lmMouseCellY = lNewMouseCellY
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    bmMouseDown = False
End Sub

Private Sub Form_Paint()
    DrawGrid
End Sub

Private Sub Form_Resize()
    
    PowerForm1.MinHorizontalScroll = 0
    If lcCellWidth * lcCellsX > ScaleWidth Then
        PowerForm1.MaxHorizontalScroll = lcCellWidth * lcCellsX - ScaleWidth
    Else
        'The entire width of the grid is visible, so
        'no need for a horizontal scroll bar.
        PowerForm1.MaxHorizontalScroll = 0
    End If
    If lcCellHeight * lcCellsY > ScaleHeight Then
        PowerForm1.MaxVerticalScroll = lcCellHeight * lcCellsY - ScaleHeight
    Else
        'The entire height of the grid is visible, so
        'no need for a vertical scroll bar.
        PowerForm1.MaxVerticalScroll = 0
    End If
    
    DrawGrid
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Unload Form2
End Sub

Private Sub PowerForm1_HorizontalScroll(ByVal ScrollEvent As AkemiPowerPack.HorizontalScrollEvent, ByVal Position As Long, Cancel As Boolean)
    'Store the current scroll position
    lmHorizontalScrollPos = Position
    
    'Draw the grid
    '(An improvement would be to only draw the portion of the
    'map that has just scrolled into view.)
    DrawGrid
End Sub

Private Sub PowerForm1_VerticalScroll(ByVal ScrollEvent As AkemiPowerPack.VerticalScrollEvent, ByVal Position As Long, Cancel As Boolean)
    lmVerticalScrollPos = Position
    
    'Draw the grid
    '(An improvement would be to only draw the portion of the
    'map that has just scrolled into view.)
    DrawGrid
End Sub

Private Sub DrawGrid()
    Dim lCellX As Long
    Dim lCellY As Long
    Dim lLeftCell As Long 'Index of left-most visible cell.
    Dim lTopCell As Long 'Index of top-most visible cell.
    Dim lVisibleCellsX As Long
    Dim lVisibleCellsY As Long
    Dim x As Long
    Dim y As Long
    Dim lImageIndex As Long
    Dim ctlImage As Control
    
    lLeftCell = lmHorizontalScrollPos \ lcCellWidth
    lTopCell = lmVerticalScrollPos \ lcCellHeight
   
    lVisibleCellsX = ScaleWidth \ lcCellWidth + 1
    lVisibleCellsY = ScaleHeight \ lcCellHeight + 1
    
    'Limit number of visible cells based on number of actual cells.
    If lVisibleCellsX > lcCellsX - lLeftCell Then
        lVisibleCellsX = lcCellsX - lLeftCell
    End If
    If lVisibleCellsY > lcCellsY - lTopCell Then
        lVisibleCellsY = lcCellsY - lTopCell
    End If
    
    For lCellX = lLeftCell To lLeftCell + lVisibleCellsX
        For lCellY = lTopCell To lTopCell + lVisibleCellsY
            x = lCellX * lcCellWidth - lmHorizontalScrollPos
            y = lCellY * lcCellHeight - lmVerticalScrollPos
'            Line (x, y)-(x + lcCellWidth, y), 0
'            Line (x + lcCellWidth, y)-(x + lcCellWidth, y + lcCellHeight), 0
            lImageIndex = almCellImageIndex(lCellX, lCellY)
            Set ctlImage = imgm(lImageIndex)
            PaintPicture ctlImage.Picture, x, y
        Next lCellY
    Next lCellX
    
End Sub

Private Sub InitializeMap()
    Dim lCellX As Long
    Dim lCellY As Long
    
    For lCellX = 0 To lcCellsX
        For lCellY = 0 To lcCellsY
            almCellImageIndex(lCellX, lCellY) = 7
        Next lCellY
    Next lCellX
End Sub

Public Sub WriteMapFile(ByVal sFileName As String)
    Dim lCellX As Long
    Dim lCellY As Long
    Dim sLine As String
    
    Open sFileName For Output As #1
    For lCellY = 0 To lcCellsY
        sLine = ""
        For lCellX = 0 To lcCellsX
            sLine = sLine & Chr$(64 + almCellImageIndex(lCellX, lCellY))
        Next lCellX
        Print #1, sLine
    Next lCellY
    Close
End Sub

Public Sub LoadMapFile(ByVal sFileName As String)
    Dim lCellX As Long
    Dim lCellY As Long
    Dim sLine As String
    
    Open sFileName For Input As #1
    For lCellY = 0 To lcCellsY
        Line Input #1, sLine
        For lCellX = 0 To lcCellsX
            almCellImageIndex(lCellX, lCellY) = Asc(Mid$(sLine, lCellX + 1, 1)) - 64
        Next lCellX
    Next lCellY
    Close
End Sub
